#!/usr/bin/python

import sys

fname = sys.argv[1] # file to find in

data = map(ord, open(fname).read())
fsize = len(data)
pos = 0

imgs = []


while pos < fsize:
    w = data[pos+1] << 8 | data[pos] ; pos += 2
    h = data[pos+1] << 8 | data[pos] ; pos += 2
    print w, h
    img = []
    for y in xrange(0, h+1):
        x = 0
        ln = [0]*w
        bc = w/4 if w%4==0 else w/4+1
        for xb in xrange(0, bc):
            b = data[pos]
            for dx in xrange(6,-2,-2):
                ln[x] = (b >> dx) & 3
                x += 1
                if x >= w: break
            pos += 1
        img.append(ln)
    imgs.append(img)
    print data[pos:pos+15]
    # ??? spare line
    pos += 2
    while pos < fsize and data[pos] == 255:
        pos += 1
    #if len(imgs) == 28: pos -= 2
    print '-', len(imgs), '-', pos, data[pos:pos+10]
    if len(imgs) == 29: pos += 2
    if len(imgs) > 0: break


pal = (' ','.','x','M')

for img in imgs:
    for ln in img:
        print ''.join([pal[c] for c in ln]) + '|'
    print '-'*len(img[0])
